Attribute VB_Name = "Module1"
'Se evita la utilizacin de variables no declaradas.
Option Explicit

Public Const ALTO_CUADRO As Integer = 375
Public Const ANCHO_CUADRO As Integer = 375
'Estas constantes almacenan el Ancho y el alto de cada cuadro del tablero.

Private Enum estado
    HA_TERMINADO
    NO_HA_TERMINADO
End Enum
Dim JUEGO As estado
'La variable JUEGO ser utilizada para comprobar si el juego
'ha terminado o debe seguir.

Dim nivel_actual As Integer
'En esta variable se almacenar el valor del nivel de juego.

Dim columnas As Integer
Dim filas As Integer
Dim minas As Integer
'Estas variables almacenarn el nmero de columnas, filas
'y minas que tendr el tablero.

Dim banderas As Integer
'Esta variable reflejar el nmero de banderas que se pondrn en el tablero.

Dim aciertos As Integer
'Esta variable ser incrementada cada vez que una bandera sea puesta en un
'cuadro que contenga una mina.

Private Type Tableros
    cuadro As Image
    tiene_mina As Boolean
    tiene_bandera As Boolean
    est_abierto As Boolean
End Type
Dim tablero() As Tableros
'La matriz dinmica tableros ser la encargada de contener los
'cuadros del tablero y el estado en que se encuentren.

Public Sub ACCIN()
    
    If JUEGO = HA_TERMINADO Then
    'Verifica si el valor de la variable JUEGO es EL_JUEGO_HA_TERMINADO.
    'En caso afirmativo ...
       Call NUEVO_JUEGO
       '... Ejecuta el procedimiento NUEVO_JUEGO ...
    Else
    '... En cualquier otro caso ...
        Exit Sub
        '... Regresa al procedimiento que lo haya invocado.
    End If
End Sub

Public Sub DEFINIR_CAMPO(Nivel As Integer)
    
    nivel_actual = Nivel
    'Nivel es el parmetro que recibe el procedimiento DEFINIR_CAMPO.
    'Es asignado a la variable nivel_actual, para evitar que se pierda.
    
    Select Case Nivel
    'Se utiliza el valor de Nivel para determinar la cantidad de filas,
    'columnas y minas se desea implantar en el tablero.
    Case 0
        'En nivel bsico habr un total de 81 cuadros (9 filas * 9 columnas) y
        '10 minas.
        
        columnas = 9
        filas = 9
        minas = 10
     Case 1
        'El nivel intermedio, el tablero contendr 256 cuadros y 40 minas.
        
        columnas = 16
        filas = 16
        minas = 40
    Case 2
        'Los avanzados tendrn que descubrir cada una de las 100 minas que se
        'escondern entre los 625 cuadros de este nivel.
        
        columnas = 25
        filas = 25
        minas = 100
    End Select
    
    'Una vez definido el tablero, se llama al procedimiento que se
    'encargar de dibujarlo.
    Call DIBUJAR_TABLERO(columnas, filas)
End Sub

Private Sub DIBUJAR_TABLERO(columnas As Integer, filas As Integer)

    Dim posicinX As Integer
    Dim posicinY As Integer
    'Estas variables son necesarias para decidir en que lugar del tablero
    'se debe poner cada cuadro.
    
    Dim i As Integer
    Dim j As Integer
    Dim k As Integer

    ReDim tablero(columnas, filas)
    'Comenzamos con las matrices dinmicas. Aqu redimensionamos
    'la matriz tablero para pueda contener columnas * filas elementos.
    
    k = 1
    'Se le asigna a k el valor de 1. Esta variable se utilizar para
    'cargar controles dinmicos.
    
    '----------------------------------------------------------------------------
    
    'Las siguientes instrucciones se encargan de organizar el
    'tamao del formulario "Busca minas" y sus componentes.
    Busca_minas.contenedor.Left = 0
    Busca_minas.Height = Busca_minas.contenedor.Height + (ALTO_CUADRO * filas) + (2 * ALTO_CUADRO)
    Busca_minas.Width = ANCHO_CUADRO * (columnas + 1 / 3)
    Busca_minas.contenedor.Width = Busca_minas.Width - 100
        
    posicinX = 0
    'Le damos el valor de 0 a la variable posicinX para que se refiera
    'al margen izquierdo del formulario "Busca minas".
    
    posicinY = Busca_minas.contenedor.Top + Busca_minas.contenedor.Height
    'posicinY indica la margen vertical que ser utilizada para
    'poner los controles.
    
    Busca_minas.contenedor.Caption = "Minas restantes: " & minas
    'En la etiqueta contenedor del formulario "Busca minas",
    'se indica el nmero de minas que se encuentran en el tablero.
    
    For j = 1 To filas
        For i = 1 To columnas
            'Se cargan los controles que van a ser utilizados.
            
            Load Busca_minas.cuadro(k)
            With tablero(i, j)
                'Se asigna el cuadro que se acaba de crear al objeto
                '"tablero.cuadro" en la posicin i, j...
                Set .cuadro = Busca_minas.cuadro(k)
                
                '... Y se niega el valor de cuadro.est_abierto.
                .est_abierto = False
                
               End With
               
            With tablero(i, j).cuadro
                'Cada control "tablero(i, j).cuadro" estar alineado segn
                'el valor de posicinX y posicinY.
                .Left = posicinX
                .Top = posicinY
                
                'Ahora se hace visible el control "tablero(i, j).cuadro"
                .Visible = True
                
            End With
            
            k = k + 1
            'Se aumenta en uno el valor de k, para que en la prxima
            'ejecucin de este bucle se cree un nuevo control.
            
            posicinX = posicinX + ANCHO_CUADRO
            'Se incrementa en "ANCHO_CUADRO" unidades la margen
            'izquierda.
        Next i
        
        posicinX = 0
        'Despus de haber completado toda una fila de cuadros, se vuelve
        'a comenzar desde el primer valor de la margen izquierda, ...
        
        posicinY = posicinY + ALTO_CUADRO
        '... Pero teniendo en cuenta que se debe cambiar de fila.
        
    Next j
    
    Call MINAR_CAMPO(columnas, filas, minas)
    'Ahora que se ha dibujado el tablero, es posible minarlo.
    
End Sub

Public Function ENCONTRAR_FILA(Index As Integer) As Integer
    
    ENCONTRAR_FILA = Int(Index / columnas) + 1
    If Index Mod columnas = 0 Then ENCONTRAR_FILA = ENCONTRAR_FILA - 1
    'Esto lo utilizamos por comodidad y para hacer ms til el ejemplo.
    'Como queremos trabajar con "cuadro()" cmo si fuera una
    'matriz bidimensional, pero es imposible hacer eso con las
    'matrices de controles, la insertamos dentro de la matriz
    'tablero y a ella le asignamos dos dimensiones.
    
    'Esto nos obliga a crear las funciones ENCONTRAR_FILA y
    'ENCONTRAR_COLUMNA, para encontrar los ndices i, j apropiados para
    'cada "tablero(i, j).cuadro", a partir de "Busca_minas.cuadro(k)".
    
    'Un procedimiento artificioso, pero ilustrativo.
    
End Function

Public Function ENCONTRAR_COLUMNA(Index As Integer) As Integer

   ENCONTRAR_COLUMNA = (Index Mod (columnas))
   If ENCONTRAR_COLUMNA = 0 Then ENCONTRAR_COLUMNA = columnas
End Function

Public Sub DESCARGAR_CONTROLES()

Dim i As Integer
Dim j As Integer
'Variables de control del procedimiento.

For j = 1 To filas
'Se recorren todas las filas...

    For i = 1 To columnas
    '... Y todas las columnas ...
    
        With tablero(i, j)
        Unload .cuadro
        Set .cuadro = Nothing
        '... Para descargar cada cuadro, ...
        
        .est_abierto = False
        .tiene_bandera = False
        .tiene_mina = False
        '... Y hacer falsas las dems variables de la matriz "tablero()".
        
        End With
    Next i
Next j

minas = 0
banderas = 0
aciertos = 0
JUEGO = NO_HA_TERMINADO
'Se limpia toda la informacin innecesaria.

End Sub

Public Sub NUEVO_JUEGO()
    
    Call DESCARGAR_CONTROLES
    'Cada que se comienze un nuevo juego es necesario descartar los valores
    'de las variables utilizadas y los controles
    'creados.
    
    Call DEFINIR_CAMPO(nivel_actual)
    'Se inicia un nuevo juego.
End Sub


Public Sub MINAR_CAMPO(columnas As Integer, filas As Integer, minas As Integer)

    Randomize
    'Se Inicializa el generador de nmeros aleatorios.
    
    Dim i As Integer
    Dim j As Integer
    Dim k As Integer
    'Se Declaran las variables que sern utilizadas para llevar a cabo
    'las operaciones de este procedimiento.
    
    For i = 1 To minas
    'Por cada mina ...

        j = Int((columnas) * Rnd + 1)
        k = Int((filas) * Rnd + 1)
        '... Se genera un par de nmeros aleatorios, que sern
        'utilizados cmo indices de los cuadros que sern minados.

        While (tablero(j, k).tiene_mina = True)
            j = Int(Rnd * columnas)
            k = Int(Rnd * filas)
            'En caso de que se mine un cuadro que ya lo estaba, se repite
            'el proceso hasta que se logre ubicar una mina en un sitio vaco.
        Wend

        tablero(j, k).tiene_mina = True
        'Se hace verdadero el valor de "tablero(j, k).tiene_mina".
        
    Next i
    

End Sub

Public Sub ABRIR_CUADRO(esta_fila As Integer, esta_columna As Integer)

    Dim i As Integer
    Dim j As Integer
    Dim k As Integer
    k = 0
    Dim restaFil As Integer
    Dim sumaFil As Integer
    Dim restaCol As Integer
    Dim sumaCol As Integer
    Dim restaFil1 As Integer
    Dim sumaFil1 As Integer
    Dim restaCol1 As Integer
    Dim sumaCol1 As Integer
    'Se Declaran las variables que sern utilizadas para llevar a cabo
    'las operaciones de este procedimiento.
        
    If (tablero(esta_columna, esta_fila).tiene_bandera = True) Then Exit Sub
    'En caso de que el cuadro presionado tenga una bandera, se evita que sea
    'abierto por error.
    
    If (tablero(esta_columna, esta_fila).est_abierto = True) Then Exit Sub
    'Un cuadro abierto no puede destaparse de nuevo.
    
    If (tablero(esta_columna, esta_fila).tiene_mina = True) Then
    'Si el cuadro que se va a destapar tiene una mina ...
        
        tablero(esta_columna, esta_fila).est_abierto = True
        '... El cuadro ser abierto ...
        
        Call BANG(esta_columna, esta_fila)
        '... Y el procedimiento BANG ser ejecutado.
        
        Exit Sub
    End If
    
    If (tablero(esta_columna, esta_fila).est_abierto = False) Then
    'Si el cuadro no est abierto, se abre.
    'Como debemos evitar cualquier intento de abrir un cuadro
    'inexistente, se utiliza este grupo de comprobaciones y asignaciones
    'antes de seguir adelante.
        
        If esta_columna = 1 Then
            restaCol = 0
        Else
            restaCol = 1
        End If
        
        If esta_columna = columnas Then
            sumaCol = 0
        Else
            sumaCol = 1
        End If
        
        If esta_fila = 1 Then
            restaFil = 0
        Else
            restaFil = 1
        End If
        
        If esta_fila = filas Then
            sumaFil = 0
        Else
            sumaFil = 1
        End If
        
        For j = esta_fila - restaFil To esta_fila + sumaFil
        'Desde la casilla que se encuentra en la fila anterior
        '(slo si existe la fila anterior), hasta el cuadro que
        'se encuentra en la fila posterior (si es que existe),
        'este bucle For ejecutar su contenido.
        
            For i = esta_columna - restaCol To esta_columna + sumaCol
            'Igual que el anterior, pero con columnas.
            
                If (tablero(i, j).tiene_mina = True) Then k = k + 1
                'Si las casillas adyacentes a la que se haya presionado
                'contienen alguna mina, la variable k ser incrementada.
                
            Next i
        Next j
    
    tablero(esta_columna, esta_fila).cuadro.Picture = Busca_minas.fondos(k)
    'La variable k se utiliza para sealar el ndice del dibujo que mostrar
    'el nmero de minas que rodean al cuadro pulsado.
    
    tablero(esta_columna, esta_fila).est_abierto = True
    'Se alcara que el cuadro ya ha sido abierto.
    
    End If
        
    If k = 0 Then
    'Si el cuadro no tiene ninguna mina a su alrededor,
    'se comprueba el nmero de casillas que lo rodean y se asigna ese valor
    'a las variables apropiadas.
    
        If esta_columna = 1 Then
            restaCol1 = 0
        Else
            restaCol1 = 1
        End If
        
        If esta_columna = columnas Then
            sumaCol1 = 0
        Else
            sumaCol1 = 1
        End If
        
        If esta_fila = 1 Then
            restaFil1 = 0
        Else
            restaFil1 = 1
        End If
        
        If esta_fila = filas Then
            sumaFil1 = 0
        Else
            sumaFil1 = 1
        End If
        
        For j = esta_fila - restaFil1 To esta_fila + sumaFil1
            For i = esta_columna - restaCol1 To esta_columna + sumaCol1
                'Se utilizan los valores obtenidos para hacer una llamada
                'recursiva al procedimiento ABRIR_CUADRO.
                
                Call ABRIR_CUADRO(j, i)
            Next i
        Next j
        
    End If
    
End Sub

Public Sub MARCAR_CUADRO(esta_columna As Integer, esta_fila As Integer)
    
    Dim mensaje As Variant
    
    If banderas = minas And tablero(esta_columna, esta_fila).tiene_bandera = False Then
    'El jugador tiene tantas bandera cmo minas hay en el juego ...
    
        mensaje = MsgBox("Has agotado las banderas" & vbNewLine & "Asegurate de haberlas puesto en el lugar adecuado", vbCritical, "Busca Minas: error")
        '... As que si trata de poner alguna ms, se le avisa.
        
        Exit Sub
        'Las banderas han sido agotadas.
        'Se sale del procedimiento.
        
    End If
    
    If (tablero(esta_columna, esta_fila).est_abierto = True) Then Exit Sub
    'Si la casilla est abierta, no hay razn para permitir que un usuario
    'despistado le ponga una bandera.
    
    If (tablero(esta_columna, esta_fila).tiene_bandera = True) Then
    'Si el cuadro pulsado tiene una bandera ...
    
        tablero(esta_columna, esta_fila).cuadro.Picture = Busca_minas.cuadro(0).Picture
        '... se le quita, ...
        
        tablero(esta_columna, esta_fila).tiene_bandera = False
        '.. se niega el valor de la variable
        '"tablero(esta_columna, esta_fila).tiene_bandera" ...
        banderas = banderas - 1
        '... Se actualiza el nmero de banderas que han sido puestas ...
        
        Busca_minas.contenedor.Caption = "Minas restantes: " & minas - banderas
        '... Y se muestra la informacin en la etiqueta "Busca_minas.contenedor".
        
        If (tablero(esta_columna, esta_fila).tiene_mina = True) Then
        'En caso de que la bandera retirada estuviera puesta sobre un
        'cuadro minado ...
        
            aciertos = aciertos - 1
            '...se resta un acierto.
            
    End If
        
        Exit Sub
        'Despus de quitar una bandera, ya no hay nada ms que hacer dentro de
        'este procedimiento. Se sale de l.
    End If
    
    tablero(esta_columna, esta_fila).tiene_bandera = True
    'Informamos a la casilla que acabamos de poner una bandera
    'sobre ella.
    
    tablero(esta_columna, esta_fila).cuadro.Picture = Busca_minas.cuadro_con_bandera
    'Se le pone en el cuadro el dibujo de apropiado.
    
    banderas = banderas + 1
    'Se incrementa el nmero de banderas que han sido utilizadas.
    
    If (tablero(esta_columna, esta_fila).tiene_mina) Then
    'Si el cuadro est minado ...
    
        aciertos = aciertos + 1
        '... El jugador tiene un acierto ms en su cuenta.
        
    End If
    
    If aciertos = minas Then
    'Cundo se haya acertado en todas las ocasiones ...
    
        mensaje = MsgBox("has ganado", vbOKOnly)
        '... se avisa al jugador acerca de su triunfo...
        
        Call NUEVO_JUEGO
        '... Y se carga un nuevo juego.
    End If
    
    Busca_minas.contenedor.Caption = "Minas restantes: " & minas - banderas
    'En la etiqueta Busca_minas.contenedor se ver el nmero de minas que
    'quedan. Esto se obtiene de restar al total de minas el nmero
    'de banderas que haya puesto el jugador.
    
End Sub

Private Sub BANG(columna As Integer, fila As Integer)

    Dim i As Integer
    Dim j As Integer
    'Se Declaran las variables que sern utilizadas para llevar a cabo
    'las operaciones de este procedimiento.
    
    For j = 1 To filas
        For i = 1 To columnas
        'Se hace un recorrido por los elementos de la
        'matriz tablero, para destapar todas las minas.
        
            If (tablero(i, j).tiene_mina = True) Then
            'Si el cuadro actual contiene una mina ...
            
                tablero(i, j).cuadro.Picture = Busca_minas.mina.Picture
                '...Se muestra el dibujo correspondiente.
                
            ElseIf (tablero(i, j).tiene_bandera = True) Then
            'Si el cuadro contiene una bandera, pero no una mina ....
            
                tablero(i, j).cuadro.Picture = Busca_minas.error
                '... Aparece una imagen, que informa al jugador de su error.
                
            End If
        Next i
    Next j
    
    tablero(columna, fila).cuadro.Picture = Busca_minas.explosin.Picture
    'Si se ha presionado la casilla equivocada, se ver
    'el dibujo de una terrible explosin...
    
    JUEGO = HA_TERMINADO
    '...Y la variable JUEGO indicar que todo HA_TERMINADO
    
End Sub
